const express = require('express');
const app = express()
const expressWs = require('express-ws')(app);

const PORT = 18888;
const websocket_connections = {};
const tabRep = [];

mode = "normal";

niveau = []
niveau["lent"] = [" a 9999"]
niveau["normal"] = [" a vvvv"," vvvv RRRR", " RRRR 9999"]
niveau["rapide"] = [" a llll"," llll yyyy", " yyyy KKKK"," KKKK XXXX", " XXXX 9999"]

const server = app.listen(PORT, () => {
    console.log(`App listening at http://localhost:${PORT}`);
    console.log(`WebSocket listening at ws://localhost:${PORT}`);
});

app.ws('/client', (ws, req) => {
    ws.on('message', (msg) => {
        switch (msg) {
            case "lent":
            	mode = msg;
                break;
            case "normal":
            	mode = msg;
                break;
            case "rapide":
            	mode = msg;
                break;
            case "donnerRequete":
            	if(tabRep.length){
            	    ws.send(tabRep[0]);
            	    tabRep.shift();            	    
            	}
                break;
            default:
            	let cpt = 0;
            	switch (mode) {
            	    case "lent":
            	    	for(const [ip,ws] of Object.entries(websocket_connections)) {
            	    	    if(cpt < 1){
		            	ws.send("search "+msg+niveau[mode][cpt]);
		            }
		            cpt++;
		        }
            	    	break;
            	    case "normal":
            	    	for(const [ip,ws] of Object.entries(websocket_connections)) {
            	    	    if(cpt < 3){
		            	ws.send("search "+msg+niveau[mode][cpt]);
		            }
		            cpt++;
		        }
            	    	break;
            	    case "rapide":
            	    	for(const [ip,ws] of Object.entries(websocket_connections)) {
            	    	    if(cpt < 5){
		            	ws.send("search "+msg+niveau[mode][cpt]);
		            }
		            cpt++;
		        }
            	    	break;
            	}
                break;
        }
    });
});


app.ws('/slave', (ws, req) => {
    const client_ip = req.connection.remoteAddress;
    websocket_connections[client_ip] = ws;
    
    ws.on('message', (msg) => {
        if(msg.startsWith("found"))
        {
            tabRep.push(msg.split(" ")[1]+ " = "+msg.split(" ")[2])
        }
    });
});
